﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Text.RegularExpressions;

namespace QTool
{
    class Program
    {
        static void Main(string[] args)
        {
            /*Console.WriteLine("Press\n1 to replace brackets\n2 to implement error operators");
            ConsoleKeyInfo key = Console.ReadKey(true);
            switch (key.Key)
            {
                case ConsoleKey.D1:
                    Console.WriteLine("Specify file name:");
                    comments(Console.ReadLine());
                    Console.WriteLine("Exit.");
                    break;
                case ConsoleKey.NumPad1:
                    goto case ConsoleKey.D1;
                case ConsoleKey.D2:
                    Console.WriteLine("Specify file name:");
                    errorop(Console.ReadLine());
                    Console.WriteLine("Exit.");
                    break;
                case ConsoleKey.NumPad2:
                    goto case ConsoleKey.D2;
            }*/
            //int a, b;
            //Console.WriteLine("A B");
            //string input = Console.ReadLine();
            //a = int.Parse(input.Split(' ')[0]); b = int.Parse(input.Split(' ')[1]);
            //Console.WriteLine(a + " " + b + " " + bgcd(a, b));

            //stats(200);
            //stats(100);
            //Console.WriteLine("Done");
            //path(3);
            //Console.WriteLine(bjacobi(100, 3));
            //Console.WriteLine(bgcd(54, 55));
            stat();
            //sqf();
            
            Console.ReadLine();

        }
        public static void stats(int n)
        {
            using (StreamWriter sw = new StreamWriter("stat.csv", false))
            {
                for (int a = 1; a <= n; a++)
                {
                    for (int b = 1; b <= n; b++)
                    //sw.Write(bgcd(a, b)+ ";");
                    if (a<b)
                        { sw.Write(bjacobi(a, b) + ";"); } 
                    else
                        { sw.Write(bjacobi(b, a) + ";"); }

                    sw.WriteLine();
                }
            }
        }
        public static void comments(string adress)
        {
            string text = "";
            string itext = "";
            try
            {
                using (StreamReader sr = new StreamReader(adress + ".qcl"))
                {
                    while (!sr.EndOfStream)
                    {
                        itext = sr.ReadLine();
                        if (itext.Contains("//"))
                        {
                            text += itext.Replace("//", "/*") + " */\n";
                        }
                        else
                            text += itext + "\n";
                    }
                }
                using (StreamWriter sw = new StreamWriter(adress + ".qcl"))
                {
                    sw.Write(text);
                }
                
                Console.WriteLine("Done");
            }
            catch
            { Console.WriteLine("Specified file does not exist."); }


        }
        public static void errorop(string adress)
        {
            try
            {
                string text;
                using (StreamReader sr = new StreamReader(adress + ".qcl"))
                {
                    text = sr.ReadToEnd();
                }
            
                Match match = Regex.Match(text, @"CNot\(\s?\w\[?\w?\]?,\s?\w\[?\w?\]?\)");
                while (match.Success)
                {
                    text = text.Replace(match.Value, match.Value.Replace("CNot", "CNotE"));
                    match = match.NextMatch();
                }
                
                match = Regex.Match(text, @"CNot\(\s?\w\[?\w?\]?,\s?\w\[?\w?\]?&\s?\w\[?\w?\]?\)");
                while (match.Success)
                {
                    text = text.Replace(match.Value, match.Value.Replace("CNot", "CCNotE"));
                    match = match.NextMatch();
                }

                match = Regex.Match(text, @"X\(\w\[?\w?\]?\)");
                while (match.Success)
                {
                    text = text.Replace(match.Value, match.Value.Replace("X", "XE"));
                    match = match.NextMatch();
                }
                
                // text = text.Replace("&",",");

                using (StreamWriter sw = new StreamWriter(adress + "e.qcl"))
                {
                    sw.Write(text);
                }
                if (text.Contains("CNot(") || text.Contains("X("))
                    Console.WriteLine("Some operators left without being replaced.");
                else
                Console.WriteLine("Done");

            }
            catch
            { Console.WriteLine("Specified file does not exist."); }
        }
        public static int bgcd(int a, int b)
        {
            if (a == 0)
                return 1;
            else if (a % 2 == 0 && b % 2 == 0)
                return bgcd(a / 2, b / 2) + 1;
            else if (a % 2 == 0)
                return bgcd(a / 2, b) + 1;
            else if (b % 2 == 0)
                return bgcd(a, b / 2) + 1;
            else
            {
                if (a<b)
                { int c = a; a = b; b = c; }
                return bgcd((a - b) / 2, b) + 1;
            }
                         
        }
        public static void path(int a)
        {
            int b = a, celkem = 0, pozice = 0; bool pos = false;
            for (int n = 0; n < Math.Ceiling(Math.Log(a, 2)) - 1; n++)
            {
                for (int m = 0; m < b / 2; m++)
                {
                    if (n == 0)
                    { Console.WriteLine("Base:" + 2 * m + "+" + (2 * m + 1) + "->" + m); }
                    else
                    { Console.WriteLine((celkem - b + 2 * m) + "+" + (celkem - b + 2 * m + 1) + "->" + (celkem + m)); }
                }
                if (b % 2 == 1 && pozice != 0)
                {
                    if (pos)
                    { Console.WriteLine("Base:" + pozice + "+" + (celkem - 1) + "->" + (celkem + b / 2)); pozice = 0; b++; }
                    else
                    { Console.WriteLine("Zbytek:" + pozice + "+" + (celkem - 1) + "->" + (celkem + b / 2)); pozice = 0; b++; }
                }
                else if (a % 2 != 0 && n == 0)
                { pozice = a - 1; pos = true; }
                else if (b % 2 != 0)
                { pozice = celkem - 1; pos = false; }
                celkem += b / 2;
                b = b / 2;
            }
            if (b % 2 == 0)
                Console.WriteLine("Final " + (celkem - 2) + "+" + (celkem - 1));
            else if (pos)
                Console.WriteLine("Final BASE " + (celkem - 1) + "+" + pozice);
            else
                Console.WriteLine("Final " + (celkem - 1) + "+" + pozice);



        }
        public static int bjacobi(int a, int b)
        {
            if (gcd(a, b) != 1)
                return 0;
            int c;
            if (b % 2 == 0)
            { c = a; a = b; b = c; }
            bool r = false; int d = 0;
            while (b != 1)
            {
                if (a % 2 == 0)
                {
                    a = a / 2;
                    if (b % 8 == 3 || b % 8 == 5)
                        r = r ^ true;
                    
                }
                if (a < b && a % 2 == 1)
                {
                    c = a;
                    a = b; b = c;
                    if (a % 4 == 3 && b % 4 == 3)
                        r = r ^ true;
                }
                if (a % 2 == 1)
                {
                    a = (a - b) / 2;
                    if (b % 8 == 3 || b % 8 == 5)
                        r = r ^ true;
                    //d++;
                }
                d++;
            }
            //Console.WriteLine(a + "+" + b);
            return d;
        }
        public static int gcd(int a, int b)
        {
            if (b == 0)
                return a;
            a = a % b;
            return gcd(b, a);
        }
        public static void stat()
        {
            string[] buffer;
            using (StreamReader sr = new StreamReader("stat.txt"))
            {

                buffer = sr.ReadToEnd().Split(char.Parse(","));
            }
            for (int a = 0; a < buffer.Length; a++)
            {
                //Console.WriteLine(buffer[a]);
            }
            using (StreamWriter sw = new StreamWriter("stat.txt"))
            {
                int b = 0;
                for (int a = 0; b < buffer.Length; a++)
                {
                    if (buffer[b].Contains("|" + a + ">"))
                    { Console.WriteLine(buffer[b].Remove(0,1).Split(char.Parse(" "))[0]); sw.Write(buffer[b].Remove(0, 1).Split(char.Parse(" "))[0]+";"); b++; }
                    else
                        sw.Write("0;");
                }
            }
        }
        public static void sqf()
        {
            using (StreamWriter sw = new StreamWriter("stat.txt"))
            {
                int c = 0; bool co = true;
                for (int a = 1; a <= 500; a++)
                {
                    co = true;
                    for (int b = 2; b < a; b++)
                    {
                        if (a % (Math.Pow(b, 2)) == 0)
                        { co = false; Console.WriteLine("Leaving"); break; }
                    }
                    if (co)
                        c++;
                    sw.Write(c + ";");
                }
            }
        }
    }
}
